<?php
//
// $Id: mavsfan.registered_user.manager.php, v 1.0 2001/03/16 12:00:00 $
//
// Manager for registered_user.
//
// Jason Alexander (jason@deallocation.org)
// Created on: <2001/3/16 16:00:00>
//
// Copyright (C) 2001, Deallocation Studios
//
// This program is free software; you can redistribute it and/or
// modify it under the terms of the GNU General Public License
// as published by the Free Software Foundation; either version 2
// of the License, or (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, US

//!! MavsFanForLife.com
//! This object is used for overall management operations of registered users within the system.


include_once("comm.dbConnection.php");

class registered_user_manager
{


    /*!
        This function is used to register the user account in the system.
    */
	function register_user($_user_nickname, $_user_email_addr, $_user_passwd, $_user_f_name, $_user_l_name, $_user_display_email_addr, $_user_reg_session_id)
	{
		
		// Right off the bat, let's check for duplicate email addresses.
		if ($this->check_dup_email($_user_email_addr) || 
			$this->check_dup_nickname($_user_nickname))
		{
			return false;
		}

		// Create a date.
		$aDateStruc = getdate();

		$sDate = date("Y-m-d h:i:s", mktime($aDateStruc["hours"], $aDateStruc["minutes"], $aDateStruc["seconds"], $aDateStruc["mon"], $aDateStruc["mday"], $aDateStruc["year"]));


		// Create the insert SQL statement.
		$sSQL = "INSERT INTO registered_user (" .
			   "	user_nickname, " .
			   "	user_email_addr, " .
			   "	user_password, " .
			   "    user_reg_date, " .
			   "    user_type_id, " .
			   "	user_reg_session_id, " .
			   "    user_f_name, " .
			   "    user_l_name, " .
			   "    user_display_email_addr " .
			   ") VALUES (" .
			   "	'" . $_user_nickname . "', " .
			   "	'" . $_user_email_addr . "', " .
			   "    '" . $_user_passwd . "', " .
			   "	'" . $sDate . "'," .
			   "    4, " .
			   "	'" . $_user_reg_session_id . "', " .
			   "	" . ($_user_f_name == "" ? "NULL" : "'" . $_user_f_name . "'") . ", " .
			   "	" . ($_user_l_name == "" ? "NULL" : "'" . $_user_l_name . "'") . ", " .
			   "	" . ($_user_display_email_addr == "" ? "NULL" : "'" . $_user_display_email_addr . "'") . ");";

		// Create a new DB connection.
		$conn = new dbConnection();

		// Open the connection.
		$conn->openConnection();

		// Execute the query.
		$conn->executeQuery($sSQL);

		// Send out the e-mail confirmation.
		$this->send_email_confirmation($_user_nickname, $_user_email_addr, $_user_reg_session_id);


		// If we get this far, just return true. Everything must be okay.
		return true;

	}


    /*!
		This function updates the given account ($_user_id) with the given information.
	*/
	function update_account_info($_user_id, $_user_f_name, $_user_l_name, $_user_display_email_addr, $_user_password, $_user_signature, $_user_pic_url)
	{
		// Build the SQL statement.
		$sSQL = "UPDATE registered_user " .
				"SET user_f_name = '" . $_user_f_name . "', " .
				"    user_l_name = '" . $_user_l_name . "' " .
				($_user_display_email_addr != "" ? ", user_display_email_addr = '" . $_user_display_email_addr . "' " : "") .
				($_user_password != "" ? ", user_password = '" . $_user_password . "'" : "") .
				($_user_signature != "" ? ", user_signature = '" . $_user_signature . "'" : "") .
				($_user_pic_url != "" ? ", user_pic_url = '" . $_user_pic_url . "'" : "") .
				"WHERE user_id = " . $_user_id;

		// Create the connection.
		$conn = new dbConnection();

		// Open the connection.
		$conn->openConnection();

		// Execute the query.
		$conn->executeQuery($sSQL);

	}


    /*!
		This function simply is an internal private function used to check for duplicate
		e-mail addresses when registered.
	*/
	function check_dup_email($_email_addr)
	{
		// SQL to check to see if there's another user in the system with that e-mail.
		$sSQL = "SELECT * FROM registered_user " .
				"WHERE user_email_addr = '" . $_email_addr . "';";
		
		// Create the connection.
		$conn = new dbConnection();

		// Open the connection.
		$conn->openConnection();

		// Execute the query.
		$conn->executeQuery($sSQL);

		// Get the results back.
		$results = $conn->getResults();

		// Get the record count returned.
		$record_count = mysql_num_rows($results);

		// If anything was returned, there's obviously someone registered with that e-mail addr already.
		if ($record_count >= 1)
			return true;
		
		// If not, no dups. All's well.
		return false;

	}


    /*!
		Again, this function checks for duplicate nicknames.
	*/
	function check_dup_nickname($_nickname)
	{
		// SQL to check to see if there's another user in the system with that e-mail.
		$sSQL = "SELECT * FROM registered_user " .
				"WHERE user_nickname = '" . $_nickname . "';";
		
		// Create the connection.
		$conn = new dbConnection();

		// Open the connection.
		$conn->openConnection();

		// Execute the query.
		$conn->executeQuery($sSQL);

		// Get the results back.
		$results = $conn->getResults();

		// Get the record count returned.
		$record_count = mysql_num_rows($results);

		// If anything was returned, there's obviously someone registered with that e-mail addr already.
		if ($record_count >= 1)
			return true;
		
		// If not, no dups. All's well.
		return false;

	}


    /*!
		This is a private function that grabs the session ID, and generates the e-mail message to the user.
		This is used to confirm that the user entered a valid e-mail address.
	*/
	function send_email_confirmation($_user_nickname, $_user_email_addr, $_session_id)
	{
		global $sitename;
		global $siteurl;
		global $siteslogan;
		global $email_replyto;
		global $email_replyfrom;

		// Build the e-mail message.
		$sMailMsg = "Hey " . $_user_nickname . "!\n" .
					"\n" .
					"\n" .
					"Thanks for registering with " . $sitename . "!\n" .
					"\n" .
					"There's only one more thing we need to do before you're granted full access " .
					"to " . $sitename . ": confirm your e-mail address.\n" .
					"\n" .
					"Luckily, if you received this e-mail, you're only one step away. Simply click " .
					"on the following link to finalize the confirmation:\n" .
					"\n" .
					$siteurl . "/confirmEmail.php?ID=" . $_session_id . "\n" .
					"\n" .
					"NOTE: If your e-mail reader does not highlight the previous link, you'll need to " .
					"copy and paste the address into your browser, manually.\n" .
					"\n" .
					"\n" .
					"We look forward to seeing you on " . $sitename . " soon!\n" .
					"\n" .
					"\n" .
					"- The " . $sitename . " Team\n" .
					"\n" .
					"\n" .
					"-------------------------------------------\n" .
					$siteurl . "\n" .
					$siteslogan . "\n" .
					"\n";

		// Send the e-mail.
		mail($_user_email_addr, "Confirmation Requested", 
				$sMailMsg, "From: " . $email_replyto . "\nReply-To: " . $email_replyto);

	}


    /*!
		This function is used in the "forgot password" area to send the user their account information.
	*/
	function send_account_reminder($_email_addr)
	{
		global $sitename;
		global $siteurl;
		global $siteslogan;
		global $admin_email_addr;
		global $email_replyfrom;
		global $email_replyto;

		// Build the SQL statement.
		$sSQL = "SELECT user_nickname, user_password " .
				"FROM registered_user " .
			    "WHERE user_email_addr = '" . $_email_addr . "';";
	

		// Create a new DB connection.
		$conn = new dbConnection();

		// Open the connection.
		$conn->openConnection();

		// Execute the query.
		$conn->executeQuery($sSQL);

		// Get the results back.
		$results = $conn->fetchNextRow();


		// Build the e-mail message.
		$sMailMsg = "Hey " . $results["user_nickname"] . "!\n" .
					"\n" .
					"\n" .
					"You, or someone, recently requested the account information for " .
					$sitename . ". It this was not you, have no worries -- since the " .
					"information is sent to your e-mail, no one else has received it.\n" .
					"\n" .
					"The following is your login information for " . $sitename . ":\n" .
					"\n" .
					"\tE-Mail Address: " . $_email_addr . "\n" .
					"\tPassword: " . $results["user_password"] . "\n" .
					"\n" .
					"If you continue to have problems logging in, feel free to send an e-mail " .
					"to " . $admin_email_addr . ".\n" .
					"\n" .
					"We look forward to seeing you on the site.\n" .
					"\n" .
					"\n" .
					"- The " . $sitename . " Team\n" .
					"\n" .
					"\n" .
					"-------------------------------------------\n" .
					$siteurl . "\n" .
					$siteslogan . "\n" .
					"\n";

		// Send the e-mail.
		mail($_email_addr, "Your Account Information", 
				$sMailMsg, "From: " . $email_replyto . "\nReply-To: " . $email_replyto);


	}


    /*!
		This function sends the user their information upon registration.
	*/
	function send_account_information($_email_addr)
	{
		global $sitename;
		global $siteurl;
		global $siteslogan;
		global $admin_email_addr;
		global $email_replyfrom;
		global $email_replyto;

		
		// Build the SQL statement.
		$sSQL = "SELECT user_nickname, user_password " .
				"FROM registered_user " .
			    "WHERE user_email_addr = '" . $_email_addr . "';";
	

		// Create a new DB connection.
		$conn = new dbConnection();

		// Open the connection.
		$conn->openConnection();

		// Execute the query.
		$conn->executeQuery($sSQL);

		// Get the results back.
		$results = $conn->fetchNextRow();


		// Build the e-mail message.
		$sMailMsg = "Hey " . $results["user_nickname"] . "!\n" .
					"\n" .
					"\n" .
					"Thanks for registering with " . $sitename . "!\n" .
					"\n" .
					"For your records, the following is your login information " .
					"for " . $sitename . ":\n" .
					"\n" .
					"\tE-Mail Address: " . $_email_addr . "\n" .
					"\tPassword: " . $results["user_password"] . "\n" .
					"\n" .
					"If you have any problems, feel free to send an e-mail to " .
					$admin_email_addr . ".\n" .
					"\n" .
					"We look forward to seeing you on the site!\n" .
					"\n" .
					"\n" .
					"- The " . $sitename . " Team\n" .
					"\n" .
					"\n" .
					"-------------------------------------------\n" .
					$siteurl . "\n" .
					$siteslogan . "\n" .
					"\n";

		// Send the e-mail.
		mail($_email_addr, "Your Account Information", 
				$sMailMsg, "From: " . $email_replyto . "\nReply-To: " . $email_replyto);


	}


    /*!
		This function is called when the user visits the e-mail confirmation page that they are e-mailed.
	*/
	function confirm_user_email($_session_id)
	{
		// Build the SQL.
		$sSQL = "UPDATE registered_user " .
				"SET user_type_id = 3 " .
				"WHERE user_reg_session_id = '" . $_session_id . "';";

		// Create the DB connection.
		$conn = new dbConnection();

		// Open the connection.
		$conn->openConnection();

		// Execute the query.
		$conn->executeQuery($sSQL);

		// Get the actual link.
		$oLink = $conn->getConnection();

		// Check to see how many rows were affected.
		$iAffected = mysql_affected_rows($oLink);

		if ($iAffected <= 0)
		{
			return false;
		}

		// Now that it's confirmed, let's send them an email with their
		// login information.
		$sSQL = "SELECT user_email_addr " .
				"FROM registered_user " .
				"WHERE user_reg_session_id = '" . $_session_id . "';";

		// Create a new connection object.
		$conn = new dbConnection();

		// Open the connection.
		$conn->openConnection();

		// Execute the query.
		$conn->executeQuery($sSQL);

		// Get the results.
		$results = $conn->fetchNextRow();

		// Send them a record of their account information.
		$this->send_account_information($results["user_email_addr"]);

		// Return true.
		return true;

	}


    /*!
		This function is used in the login process to validate the user and password.
	*/
	function validateUser($_email_addr, $_passwd)
	{
		// SQL to pull the information, IF both the email addr and the passwd are both correct.
		$sSQL = "SELECT * " .
			    "FROM registered_user " .
			    "WHERE user_email_addr = '" . $_email_addr . "' " .
			    "  AND user_password = '" . $_passwd . "' " .
			    "  AND user_type_id <> 4;";

		// Create a connection to the DB.
		$conn = new dbConnection();

		// Open the DB connection.
		$conn->openConnection();

		// Execute the query.
		$conn->executeQuery($sSQL);

		// Get the results.
		$aResults = $conn->getResults();

		// Get the record count.
		$iRecordCount = mysql_num_rows($aResults);

		// If there were no records returned, obviously validation has failed.
		if ($iRecordCount <= 0)
		{
			return false;
		}

		while($aNewResults = mysql_fetch_array($aResults))
		{
			// Now, we need to get read information from the database, as well.
			$SQL = "SELECT * " .
				   "FROM user_read_item " .
				   "WHERE user_id = " . $aNewResults["user_id"];
		
			$conn->executeQuery($SQL);
	
			while ($rsReadItems = $conn->fetchNextRow())
			{
				$aReadItems[trim($rsReadItems["item_id"])] = array(
									"item_type"			=> $rsReadItems["item_type"],
									"item_id"			=> $rsReadItems["item_id"],
									"user_read_date"	=> $rsReadItems["item_read_date"]);
			
			}

			// Assuming all went well, let's enumerate the associative array.
			$aUserInfo = array(
								"user_id"					=> $aNewResults["user_id"],
								"user_nickname"				=> $aNewResults["user_nickname"],
								"user_f_name"				=> $aNewResults["user_f_name"],
								"user_l_name"				=> $aNewResults["user_l_name"],
								"user_password"				=> $aNewResults["user_password"],
								"user_type_id"				=> $aNewResults["user_type_id"],
								"user_email_addr"			=> $aNewResults["user_email_addr"],
								"user_display_email_addr"	=> $aNewResults["user_display_email_addr"],
								"user_signature"			=> $aNewResults["user_signature"],
								"user_pic_url"				=> $aNewResults["user_pic_url"],
								"user_collapse_threads"		=> $aNewResults["user_collapse_threads"],
								"user_read_items"			=> $aReadItems);

		}


		// Return the user array back to the calling interface.
		return $aUserInfo;
	}


	function changeThreadMode($_user_id, $_thread_mode)
	{

		$sSQL = "UPDATE registered_user " .
				"SET user_collapse_threads = " . ($_thread_mode ? "1" : "0") . " " .
				"WHERE user_id = " . $_user_id;


		// Create a connection to the DB.
		$conn = new dbConnection();

		// Open the DB connection.
		$conn->openConnection();

		// Execute the query.
		$conn->executeQuery($sSQL);

	}


}

?>