<?
/*
          Newsportal NNTP<->HTTP Gateway 
 
 Version: 0.23pre3

 this Script is licensed under the GNU Public License

 Author: Florian Amrhein
 eMail: florian.amrhein@gmx.de
 Homepage: http://floh.gartenhaus.net
*/

/*
 * the name and the description of a newsgroup
 */
class newsgroupType {
  var $name;
  var $description;
  var $count;
  var $last_post_date;
}

/*
 * Stores the Header of an article
 */
class articleType {
  var $number; // the Number of an article inside a group
  var $id;     // Message-ID
  var $from;   // eMail of the author
  var $name;   // Name of the author
  var $subject; // the subject
  var $newsgroups;  // the Newsgroups where the article belongs to
  var $followup;
  var $date;
  var $organization;
  var $references;
  var $content_transfer_encoding;
  var $answers;
  var $isAnswer;
  var $username;
  var $user_agent;
  var $isReply;
  var $pictureURL;
}

/*
 * opens the connection to the NNTP-Server
 *
 * $server: adress of the NNTP-Server
 * $port: port of the server
 */
function OpenNNTPconnection($server,$port) {
  global $text_error,$server_auth_user,$server_auth_pass,$readonly;
  $ns=fsockopen($server,$port);
  $weg=lieszeile($ns);  // kill the first line
  if (substr($weg,0,2) != "20") {
    $ns=false;
    echo "<p>".$text_error["error:"]."</p>";
  } else {
    if ($ns != false) {
      fputs($ns,"mode reader\r\n");
      $weg=lieszeile($ns);  // and once more
      if (substr($weg,0,2) != "20") {
        $ns=false;
        echo "<p>".$text_error["error:"]."</p>";
      }
    }
    if ((isset($server_auth_user)) && (isset($server_auth_pass)) &&
        ($server_auth_user != "")) {
      fputs($ns,"authinfo user $server_auth_user\r\n");
      $weg=lieszeile($ns);
      fputs($ns,"authinfo pass $server_auth_pass\r\n"); 
      $weg=lieszeile($ns);
      if (substr($weg,0,3) != "281") {
        $ns=false;
        echo "<p>".$text_error["error:"]."</p>";
        echo "<p>".$text_error["auth_error"]."</p>";  
      }
    }
  }
  if ($ns == false) echo "<p>".$text_error["connection_failed"]."</p>";
  return $ns;
}

/*
 * Close a NNTP connection
 *
 * $von: the handle of the connection
 */
function closeNNTPconnection(&$von) {
  if ($von != false) {
    fputs($von,"quit\r\n");
    fclose($von);
  }
}

/*
 * Validates an email adress
 */
function validate_email($adress)
{
  global $validate_email;
  $return=true;
  if (($validate_email >= 1) && ($return == true))
    $return = (ereg('^[-!#$%&\'*+\\./0-9=?A-Z^_A-z{|}~]+'.'@'.
               '[-!#$%&\'*+\\/0-9=?A-Z^_A-z{|}~]+\.'.
               '[-!#$%&\'*+\\./0-9=?A-Z^_A-z{|}~]+$',$adress));
  if (($validate_email >= 2) && ($return == true)) {
    $adressarray=adressDecode($adress,"garantiertungueltig");
    $return=checkdnsrr($adressarray[0]["host"],"MX");
    if (!$return) $return=checkdnsrr($adressarray[0]["host"],"A");
  }
  return($return);
}

function showPageSelectMenu($article_count,$first) {
  global $articles_per_page,$file_thread,$file_framethread,$name;
  if (isset($file_framethread)) {
    $thread=$file_framethread;
  } else {
    $thread=$file_thread;
  }
  $pages=ceil($article_count / $articles_per_page);
  if ($article_count > $articles_per_page)
    for ($i = 0; $i < $pages; $i++) {
      echo '[';
      if ($first != $i*$articles_per_page+1)
        echo '<a href="'.$thread.'?name='.urlencode($name).
             '&first='.($i*$articles_per_page+1).
             '&last='.($i+1)*$articles_per_page.'">';
      echo ($i*$articles_per_page+1).'-';
      if ($i == $pages-1) {
        echo $article_count;
      } else {
        echo ($i+1)*$articles_per_page;
      }
      if ($first != $i*$articles_per_page+1)
        echo '</a>';
      echo '] ';
    }
}

function testGroup($groupname) {
  global $testgroup;
  if ($testgroup) {
    $gf=fopen("groups.txt","r");
    while (!feof($gf)) {
      $read=trim(lieszeile($gf));
      $pos=strpos($read," ");
      if ($pos != false) {
        if (substr($read,0,$pos)==trim($groupname)) return true;
      } else {
        if ($read == trim($groupname)) return true;
      }
    }
    fclose($gf);
    return false;
  } else {
    return true;
  }
}

function testGroups($newsgroups) {
  $groups=explode(",",$newsgroups);
  $count=count($groups);
  $return="";
  $o=0;
  for ($i=0; $i<$count; $i++) {
    if (testgroup($groups[$i])) {
      if ($o>0) $return.=",";
      $o++;
      $return.=$groups[$i];
    }
  }
  return($return);
}

/*
 * read one line from the NNTP-server
 */
function lieszeile(&$von) {
  if ($von != false) {
    $t=ereg_replace("\r\n$","",fgets($von,100000));
    return $t;
  }
}


function adressDecode($adrstring,$defaulthost) {
  $parsestring=trim($adrstring);
  $len=strlen($parsestring);
  $at_pos=strpos($parsestring,'@');     // find @
  $ka_pos=strpos($parsestring,"(");     // find (
  $kz_pos=strpos($parsestring,')');     // find )
  $ha_pos=strpos($parsestring,'<');     // find <
  $hz_pos=strpos($parsestring,'>');     // find >
  $space_pos=strpos($parsestring,')');  // find ' '
  $email="";
  $mailbox="";
  $host="";
  $personal="";
  if ($space_pos != false) {
    if (($ka_pos != false) && ($kz_pos != false)) {
      $personal=substr($parsestring,$ka_pos+1,$kz_pos-$ka_pos-1);
      $email=trim(substr($parsestring,0,$ka_pos-1));
    }
  } else {
    $email=$adrstring;
  }
  if (($ha_pos != false) && ($hz_pos != false)) {
    $email=trim(substr($parsestring,$ha_pos+1,$hz_pos-$ha_pos-1));
    $personal=substr($parsestring,0,$ha_pos-1);
  }
  if ($at_pos != false) {
    $mailbox=substr($email,0,strpos($email,'@'));
    $host=substr($email,strpos($email,'@')+1);
  } else {
    $mailbox=$email;
    $host=$defaulthost;
  }
  $personal=trim($personal);
  if (substr($personal,0,1) == '"') $personal=substr($personal,1);
  if (substr($personal,strlen($personal)-1,1) == '"')
    $personal=substr($personal,0,strlen($personal)-1);
  $result["mailbox"]=trim($mailbox);
  $result["host"]=trim($host);
  if ($personal!="") $result["personal"]=$personal;
  $complete[]=$result;
  return ($complete);
}


function readGroups($server,$port) {

  $ns = OpenNNTPconnection($server,$port);
  
  if ($ns == false) return false;
  
  $gf = fopen("groups.txt","r");

  while (!feof($gf)) {
    $gruppe = new newsgroupType;

	$tmp = trim(lieszeile($gf));

    $pos = strpos($tmp," ");

    if ($pos != false) {

      $gruppe->name = substr($tmp, 0, $pos);
      $desc = substr($tmp, $pos);

	} else {

      $gruppe->name = $tmp;

      fputs($ns, "xgtitle $gruppe->name\r\n");

      $response = liesZeile($ns);

      if (strcmp(substr($response,0,3),"282") == 0) {
        $neu=liesZeile($ns);
        do {
          $response=$neu;
          if ($neu != ".") $neu=liesZeile($ns);
        } while ($neu != ".");
        $desc=strrchr($response,"\t");
        if (strcmp($response,".") == 0) {
          $desc="-";
        }
      } else {
        $desc=$response;
      }

      if (strcmp(substr($response,0,3),"500") == 0)
        $desc="-";
    }
    if (strcmp($desc,"") == 0) $desc="-";
    $gruppe->description=$desc;
    fputs($ns,"group ".$gruppe->name."\r\n"); 
    $response=liesZeile($ns);
    $t=strchr($response," ");
    $t=substr($t,1,strlen($t)-1);
    $gruppe->count=substr($t,0,strpos($t," "));
    if ((strcmp(trim($gruppe->name),"") != 0) &&
        (substr($gruppe->name,0,1) != "#"))
      $newsgroups[]=$gruppe;
  }
  fclose($gf);
  closeNNTPconnection($ns);
  return $newsgroups;
}

/*
 * print the group names from an array to the webpage
 */
function showgroups($gruppen) {
  if ($gruppen == false) return;
  global $file_thread,$text_groups;
  $c = count($gruppen);
  echo "<table>\n";
  echo "<tr><td>#</td><td>".$text_groups["newsgroup"].
       "</td><td>".$text_groups["description"]."</td></tr>\n";
  for($i = 0 ; $i < $c ; $i++) {
    $g = $gruppen[$i];
    echo "<tr><td>";
    echo "$g->count</td><td>";
    echo '<a ';
    if ((isset($frame_threadframeset)) && ($frame_threadframeset != ""))
      echo 'target="'.$frame_threadframeset.'" ';
    echo 'href="'.$file_thread.'?name='.urlencode($g->name).'">'.$g->name."</a></td>\n";
    echo "<td>$g->description</td></tr>\n";
    flush();
  }
  echo "</table>\n";
}

/*
 gets a list of aviable articles in the group $groupname
 */
function getArticleList(&$von,$groupname) {
  fputs($von,"listgroup $groupname \r\n");
  $zeile=lieszeile($von);
  $zeile=lieszeile($von);
  while(strcmp($zeile,".") != 0) {
    $articleList[] = trim($zeile);
    $zeile=lieszeile($von);
  }
  if (!isset($articleList)) $articleList="-";
  return $articleList;
}

function headerDecode($value) {
  if (eregi('=\?.*\?Q\?.*\?=',$value)) {
    $result=eregi_replace('(.*)=\?.*\?Q\?(.*)\?=(.*)','\1\2\3',$value);
    if ($value != $result) $result=headerDecode($result);
    $result=str_replace("_"," ",quoted_printable_decode($result));
    return($result);
  }
  if (eregi('=\?.*\?B\?.*\?=',$value)) {
    $result=eregi_replace('(.*)=\?.*\?B\?(.*)\?=(.*)','\1\2\3',$value);
    if ($value != $result) $result=headerDecode($result);
    $result=str_replace("_"," ",base64_decode($result));
    return($result);
  }

  return($value);
}

function getTimestamp($value) {
  $months=array("Jan"=>1,"Feb"=>2,"Mar"=>3,"Apr"=>4,"May"=>5,"Jun"=>6,"Jul"=>7,"Aug"=>8,"Sep"=>9,"Oct"=>10,"Nov"=>11,"Dec"=>12);
  $value=str_replace("  "," ",$value);
  $d=split(" ",$value,5);
  if (strcmp(substr($d[0],strlen($d[0])-1,1),",") == 0) {
    $date[0]=$d[1];  // day
    $date[1]=$d[2];  // month
    $date[2]=$d[3];  // year
    $date[3]=$d[4];  // hours:minutes:seconds
  } else {
    $date[0]=$d[0];  // day
    $date[1]=$d[1];  // month
    $date[2]=$d[2];  // year
    $date[3]=$d[3];  // hours:minutes:seconds
  }
  $time=split(":",$date[3]);
  $timestamp=mktime($time[0],$time[1],$time[2],$months[$date[1]],$date[0],$date[2]);
  return $timestamp;
}

/*
 * read the header of an article.
 * $articleNumber can be the number of an article or its message-id.
 */
function readHeader(&$von, $group, $articleNumber, $_user_hash) {
  global $text_error;
  fputs($von,"group $group\r\n");
  $zeile=lieszeile($von);
  fputs($von,"head $articleNumber\r\n");
  $zeile=lieszeile($von);
  if (substr($zeile,0,3) != "221") {
    echo $text_error["article_not_found"];
    $header=false;
    return;
  }
  $hdr=array();
  $zeile=lieszeile($von);
  while(strcmp($zeile,".") != 0) {
    $hdr[]=$zeile;
    $zeile=lieszeile($von);

  }
  for ($i=count($hdr)-1; $i>0; $i--)
    if (preg_match("/^(\x09|\x20)/",$hdr[$i]))
      $hdr[$i-1]=$hdr[$i-1].ltrim($hdr[$i]);
  $header = new articleType;
  $header->isAnswer=false;
  for ($count=0;$count<count($hdr);$count++) {
    $variable=substr($hdr[$count],0,strpos($hdr[$count]," "));
    $value=trim(substr($hdr[$count],strpos($hdr[$count]," ")+1));
      switch ($variable) {
        case "From:": 
          $fromline=adressDecode(headerDecode($value),"nirgendwo");
          if (!isset($fromline[0]["host"])) $fromline[0]["host"]="";
          $header->from=$fromline[0]["mailbox"]."@".$fromline[0]["host"];
          $header->username=$fromline[0]["mailbox"];
          if (!isset($fromline[0]["personal"])) {
            $header->name="";
          } else {
            $header->name=$fromline[0]["personal"];
          }
          break;
        case "Message-ID:":
          $header->id=$value;
          break;
        case "Subject:":
          $header->subject=headerDecode($value);
          break;
        case "Newsgroups:":
          $header->newsgroups=$value;
          break;
        case "Organization:":
          $header->organization=$value;
          break;
        case "Content-Transfer-Encoding:":
          $header->content_transfer_encoding=trim(strtolower($value));
          break;
        case "References:":
          $ref=trim($value);
          while (strpos($ref,"> <") != false) {
            $header->references[]=substr($ref,0,strpos($ref," "));
            $ref=substr($ref,strpos($ref,"> <")+2);
          }
          $header->references[]=trim($ref);
          break;
        case "Date:":
          $header->date=getTimestamp(trim($value));
          break;
        case "Followup-To:":
          $header->followup=trim($value);
          break;
        case "X-Newsreader:":
        case "X-Mailer:":
        case "User-Agent:":
          $header->user_agent=trim($value);
      }
  }
  if (!isset($header->content_transfer_encoding))
    $header->content_transfer_encoding="8bit";
  $header->pictureURL = $_user_hash[$header->name]["user_pic_url"];
  return $header;
}


function textwrap($text, $wrap=80, $break="\n"){
  $len = strlen($text);
  if ($len > $wrap) {
    $h = '';        // massaged text
    $lastWhite = 0; // position of last whitespace char
    $lastChar = 0;  // position of last char
    $lastBreak = 0; // position of last break
    // while there is text to process
    while ($lastChar < $len) {
      $char = substr($text, $lastChar, 1); // get the next character
      // if we are beyond the wrap boundry and there is a place to break
      if (($lastChar - $lastBreak > $wrap) && ($lastWhite > $lastBreak)) {
        $h .= substr($text, $lastBreak, ($lastWhite - $lastBreak)) . $break;
        $lastChar = $lastWhite + 1;
        $lastBreak = $lastChar;
      }
      // You may wish to include other characters as valid whitespace...
      if ($char == ' ' || $char == chr(13) || $char == chr(10)) {
        $lastWhite = $lastChar; // note the position of the last whitespace
      }
      $lastChar = $lastChar + 1; // advance the last character position by one
    }
    $h .= substr($text, $lastBreak); // build line
  } else {
    $h = $text; // in this case everything can fit on one line
  }
  return $h;
}

/*
 * makes URLs clickable
 */
function htmlParse($comment) {
  global $frame_externallink;
  if ((isset($frame_externallink)) && ($frame_externallink != "")) { 
    $target=' TARGET="'.$frame_externallink.'" ';
  } else {
    $target=' ';
  }
  $ncomment = eregi_replace( 'http://([-a-z0-9_./~@?=%#&;\n]+)', '<a'.$target.'href="http://\1">http://\1</a>', $comment);
  if ($ncomment == $comment)
    $ncomment = eregi_replace( '(www\.[-a-z]+\.(de|int|eu|org|net|at|ch|com))','<a'.$target.'href="http://\1">\1</a>',$comment);
  $comment=$ncomment;
  $comment = eregi_replace( 'https://([-a-z0-9_./~@?=%#&;\n]+)', '<a'.$target.'href="https://\1">https://\1</a>', $comment);
  $comment = eregi_replace( 'gopher://([-a-z0-9_./~@?=%\n]+)','<a'.$target.'href="gopher://\1">gopher://\1</a>', $comment);
  $comment = eregi_replace( 'news://([-a-z0-9_./~@?=%\n]+)','<a'.$target.'href="news://\1">news://\1</a>', $comment);
  $comment = eregi_replace( 'ftp://([-a-z0-9_./~@?=%\n]+)', '<a'.$target.'href="ftp://\1">ftp://\1</a>', $comment);
  $comment = eregi_replace( '([-a-z0-9_./n]+)@([-a-z0-9_.]+)','<a href="mailto:\1@\2">\1@\2</a>', $comment);
  return($comment);
}

/*
 * read the body of an article.
 * $articleNumber can be the number of an article or its message-id.
 */
function readBody(&$von,$articleNumber,$encoding) {
  fputs($von,"body $articleNumber\r\n");
  $zeile=lieszeile($von);
  $zeile=lieszeile($von);
  $body="";
  while(strcmp(trim($zeile),".") != 0) {
    $body .= $zeile."\n";
    $zeile=lieszeile($von);
  }
  if ($encoding == "quoted-printable") {
    $body=Quoted_printable_decode($body);
  }
  $body=str_replace("\n..\n","\n.\n",ereg_replace("\r\n","\n",$body));
  return split("\n",$body);
}

/*
 * read the header of an article in plaintext into an array
 * $articleNumber can be the number of an article or its message-id.
 */
function readPlainHeader(&$von,$group,$articleNumber) {
  fputs($von,"group $group\r\n");
  $zeile=lieszeile($von);
  fputs($von,"head $articleNumber\r\n");
  $zeile=lieszeile($von);
  if (substr($zeile,0,3) != "221") {
    echo $text_error["article_not_found"];
    $header=false;
  } else {
    $zeile=lieszeile($von);
    $body="";
    while(strcmp(trim($zeile),".") != 0) {
      $body .= $zeile."\n";
      $zeile=lieszeile($von);
    }
    return split("\n",ereg_replace("\r\n","\n",$body));
  }
}

function readArticles(&$von,$groupname,$articleList) {
  for($i = 0; $i <= count($articleList)-1 ; $i++) {
    $temp=readHeader($von,$articleList[$i]);
    $articles[$temp->id] = $temp;
  }
  return $articles;
}

function splitSubject(&$subject) {
  $s=eregi_replace('^(aw:|re:|re\[2\]:| )+','',$subject);
  if ($s != $subject) { 
    $return=true;
  } else {
    $return=false;
  }
  $subject=$s;
  return $return;
}

function interpretOverviewLine($zeile,$overviewformat,$groupname) {
  
  $return="";
  
  $overviewfmt = explode("\t", $overviewformat);
  
  echo " ";                // keep the connection to the webbrowser alive
  
  flush();                 // while generating the message-tree
  
  $over = split("\t", $zeile, count($overviewfmt)-1);
  
  $article = new articleType;

  for ($i=0; $i<count($overviewfmt)-1; $i++) {

    if ($overviewfmt[$i] == "Subject:") {
      $subject = headerDecode($over[$i+1]);
      $article->isReply = splitSubject($subject);
      $article->subject = $subject;
    }

    if ($overviewfmt[$i] == "Date:") {
      $article->date = getTimestamp($over[$i+1]);
    }

    if ($overviewfmt[$i]=="From:") {
      $fromline = adressDecode(headerDecode($over[$i+1]),"nirgendwo");

      if (!isset($fromline[0]["host"])) $fromline[0]["host"] = "";

      $article->from = $fromline[0]["mailbox"]."@".$fromline[0]["host"];
      $article->username = $fromline[0]["mailbox"];
      
	  if (!isset($fromline[0]["personal"])) {
        $article->name = $fromline[0]["mailbox"];
        
		if (strpos($article->name,'%') != false) {
          $article->name = substr($article->name, 0, strpos($article->name, '%'));
        }

        $article->name = strtr($article->name, '_', ' ');

      } else {
        $article->name = $fromline[0]["personal"];
      }
    
	}

    if ($overviewfmt[$i]=="Message-ID:") $article->id = $over[$i+1];
    if (($overviewfmt[$i]=="References:") && ($over[$i+1] != ""))
      $article->references = explode(" ", $over[$i+1]);
  }

  $article->number = $over[0];

  $article->isAnswer = false;
  
  return($article);
}


/*
 * Rebuild the Overview-File 
 */
function rebuildOverview(&$von,$groupname,&$spoolopenmodus, $_user_hash) {
  global $spooldir,$maxarticles,$maxfetch,$initialfetch,$maxarticles_extra;
  global $text_error,$text_thread,$compress_spoolfiles,$server;

  $headers = array();

  $idstring="0.22,".$server.",".$compress_spoolfiles.",".$maxarticles.",".
            $maxarticles_extra.",".$maxfetch.",".$initialfetch;
  fputs($von,"list overview.fmt\r\n");  // find out the format of the
  $tmp=liesZeile($von);                 // xover-command
  $zeile=liesZeile($von);
  while (strcmp($zeile,".") != 0) {
    $overviewfmt[]=$zeile;
    $zeile=liesZeile($von);
  }
  $overviewformat=implode("\t",$overviewfmt);
  $spoolfilename=$spooldir."/".$groupname."-data.dat";
  fputs($von,"group $groupname\r\n");   // select a group
  $groupinfo=explode(" ",liesZeile($von));
  if (substr($groupinfo[0],0,1) != 2) {
    echo "<p>".$text_error["error:"]."</p>";
    echo "<p>".$text_thread["no_such_group"]."</p>";
    flush();
  } else {
    $infofilename=$spooldir."/".$groupname."-info.txt";
    $spoolopenmodus="n";
    if (!((file_exists($infofilename)) && (file_exists($spoolfilename)))) {
      $spoolopenmodus="w";
    } else {
      $infofile=fopen($infofilename,"r");
      $oldid=fgets($infofile,100);
      if (trim($oldid) != $idstring) {
        echo "<!-- Database Error, rebuilding Database...-->\n";
        $spoolopenmodus="w";
      }
      $oldgroupinfo=explode(" ",trim(fgets($infofile,200)));
      fclose($infofile);
      if ($groupinfo[3] < $oldgroupinfo[1]) {
        $spoolopenmodus="w";
      }
      if ($maxarticles == 0) {
        if ($groupinfo[2] != $oldgroupinfo[0]) $spoolopenmodus="w";
      } else {
        if ($groupinfo[2] > $oldgroupinfo[0]) $spoolopenmodus="w";
      }
      if (($spoolopenmodus == "n") && ($groupinfo[3] > $oldgroupinfo[1]))
        $spoolopenmodus="a";
    }
    if ($spoolopenmodus=="a") {
      $firstarticle=$oldgroupinfo[1]+1;
      $lastarticle=$groupinfo[3];
    }
    if ($spoolopenmodus=="w") {
      $firstarticle=$groupinfo[2];
      $lastarticle=$groupinfo[3];
    }
    if ($spoolopenmodus != "n") {
      if ($maxarticles != 0) {
        if ($spoolopenmodus == "w") {
          $firstarticle=$lastarticle-$maxarticles+1;
          if ($firstarticle < $groupinfo[2])
            $firstarticle=$groupinfo[2];
        } else {
          if ($lastarticle-$oldgroupinfo[0]+1 > $maxarticles + $maxarticles_extra) {
            $firstarticle=$lastarticle-$maxarticles+1;
            $spoolopenmodus="w";
          }
        }
      }
      if (($maxfetch!=0) && (($lastarticle-$firstarticle+1) > $maxfetch)) {
        if ($spoolopenmodus=="w") {
          $tofetch=($initialfetch != 0) ? $initialfetch : $maxfetch;
          $lastarticle=$firstarticle+$tofetch-1;
        } else {
          $lastarticle=$firstarticle+$maxfetch-1;
        }
      }
    }
    
//	echo "<!--openmodus: ".$spoolopenmodus."-->\n";
    
	if ($spoolopenmodus != "w") $headers=loadThreadData($groupname);

    if ($spoolopenmodus != "n") {
      
	  fputs($von,"xover ".$firstarticle."-".$lastarticle."\r\n");  // and read the overview
      
	  $tmp=liesZeile($von);

      if (substr($tmp,0,3) == "224") {
        
		$zeile = liesZeile($von);

        while ($zeile != ".") {
          $article = interpretOverviewLine($zeile, $overviewformat, $groupname);
		  $article->pictureURL = $_user_hash[$article->name]["user_pic_url"];

		  // Updated to use array_push, rather then keying off of article id.
          array_push($headers, $article);
		  //$headers[$article->id]=$article;        

		  $zeile = lieszeile($von);

        }
      }

	  /*
      if (file_exists($spoolfilename)) unlink($spoolfilename);
      $infofile=fopen($infofilename,"w");
      if ($spoolopenmodus=="a") $firstarticle=$oldgroupinfo[0];
      fputs($infofile,$idstring."\n");
      fputs($infofile,$firstarticle." ".$lastarticle."\r\n");
      fclose($infofile);
	  */
    }
    return((isset($headers)) ? $headers : false);
  }
}  


/*
 * Read the Overview.
 * Format of the overview-file:
 *    message-id
 *    date
 *    subject
 *    author
 *    email
 *    references
 */
function mycompare($a, $b) {
	global $thread_sorting;
	if ($a->date == $b->date) $r=0;
	$r=($a->date < $b->date) ? -1 : 1;

	return $r * $thread_sorting;
}

function readOverview(&$von,$groupname,$readmode = 1,&$spoolopenmodus, $user_hash) {
  global $text_error, $maxarticles;
  global $spooldir,$thread_sorting;
  if (!testGroup($groupname)) {
    echo $text_error["read_access_denied"];
    return;
  }
  if ($von == false) return false;
  if (($von!=false) && ($readmode > 0)) 
    $articles = rebuildOverview($von,$groupname,$spoolopenmodus, $user_hash);
  if ((isset($articles)) && ($articles)) {
    if (($thread_sorting != 0) && (count($articles)>0))
      uasort($articles,'mycompare');
    return $articles;
  } else {
    return false;
  }
}

function str_change($str,$pos,$char) {
  return(substr($str,0,$pos).$char.substr($str,$pos+1,strlen($str)-$pos));
}

function formatDate($c) {
  global $age_count,$age_time,$age_color;
  $return="";
  $currentTime=time();
  $color="";
  if ($age_count > 0)
    for($t = $age_count; $t >= 1; $t--)
      if ($currentTime - $c->date < $age_time[$t]) $color = $age_color[$t];
  if ($color != "") $return .= '<font color="'.$color.'">';
  $return .= date("d.m.",$c->date);                 // format the date
  if ($color != "") $return .= '</font>';
  return($return);
}

function calculateTree($newtree, $depth, $num, $liste, $c) {

  if ((isset($c->answers[0])) && (count($c->answers)>0)) {
    $newtree .= "*";
  } else {
    if ($depth == 1) {
      $newtree .= "o";
    } else {
      $newtree .= "-";
    }
  }
  if (($num == count($liste) - 1) && ($depth > 1)) {
    $newtree = str_change($newtree, $depth-2, "`");
  }
  return($newtree);
}


/*
 * Format the message-tree
 * Zeichen im Baum:
 *  o : leerer Kasten            k1.gif
 *  * : Kasten mit Zeichen drin  k2.gif
 *  i : vertikale Linie          I.gif
 *  - : horizontale Linie        s.gif
 *  + : T-Stueck                 T.gif
 *  ` : Winkel                   L.gif
 */
function formatTreeGraphic($newtree) {
  global $imgdir;
  
  $return="";

  for ($o = 0 ; $o < strlen($newtree); $o++) {
    $return .= '<img src="'.$imgdir.'/';

    $k = substr($newtree,$o,1);

    $alt = $k;

    switch ($k) {
      case "o":
        $return .= 'k1.gif';
        break;
      case "*":
        $return .= 'k2.gif';
        break;
      case "i":
        $return .= 'I.gif';
        $alt='|';
        break;
      case "-":
        $return .= 's.gif';
        break;
      case "+":
        $return .= 'T.gif';
        break;
      case "`":
        $return .= 'L.gif';
        break;
      case ".":
        $return .= 'e.gif';
        $alt='&nbsp;';
        break;
      }

    $return .= '" alt="' . $alt . '"';

    if (strcmp($k, ".") == 0) $return .= (' width="12" height="9"');

    $return .= ' />';
  }

  return($return);
}

function formatTreeText($tree) {
  $tree=str_replace("i","|",$tree);
  $tree=str_replace(".","&nbsp;",$tree);
  return($tree);
}

function formatSubject($c,$group) {
  if ($c->isReply) {
    $re="Re: ";
  } else {
    $re="";
  }
  global $file_article, $thread_maxSubject, $frame_article;
  $return='<a ';
  if ((isset($frame_article)) && ($frame_article != ""))
    $return .= 'target="'.$frame_article.'" ';
  $return .= 'href="'.$file_article.
       '?id='.urlencode($c->number).'&amp;group='.urlencode($group).'">'.
       $re.htmlspecialchars(substr(trim($c->subject),0,$thread_maxSubject))."</a>";
  return($return);
}

function formatAuthor($c) {
  $return = '<a href="mailto:'.trim($c->from).'">';
  if (trim($c->name)!="") { 
    $return .= htmlspecialchars(trim($c->name));
  } else {
    if (isset($c->username)) {
      $s = strpos($c->username,"%");
      if ($s != false) {
        $return .= htmlspecialchars(substr($c->username,0,$s));
      } else {
        $return .= htmlspecialchars($c->username);
      }
    }
  }
  $return .= "</a>";
  return($return);
}

function showThread(&$headers, &$liste, $depth, $tree, $group, $article_first=0, $article_last=0, &$article_count) {
  global $thread_treestyle;
  global $thread_showDate,$thread_showSubject;
  global $thread_showAuthor,$imgdir;
  global $file_article,$thread_maxSubject;
  global $age_count,$age_time,$age_color;
  global $frame_article,$thread_fontPre,$thread_fontPost;

  if ($thread_treestyle==3) echo "\n<UL>\n";
  
  
  for ($i = 0 ; $i<count($liste) ; $i++) {
  
	$c = $headers[$liste[$i]];    // read the first article
    
	$article_count++; 
    
	switch ($thread_treestyle) {
      case 4:  // thread
      case 5:  // thread, graphic
      case 6:  // thread, table
      case 7:  // thread, table, graphic
        $newtree = calculateTree($tree, $depth, $i, $liste, $c);
    }

    if (($article_first == 0) ||
	   (($article_count >= $article_first) &&
         ($article_count <= $article_last))) {

      switch ($thread_treestyle) {
        case 0: // simple list
          echo $thread_fontPre;
          if ($thread_showDate) echo formatDate($c)." ";
          if ($thread_showSubject) echo formatSubject($c,$group)." ";
          if ($thread_showAuthor) echo "(".formatAuthor($c).")";
          echo $thread_fontPost;
          echo "<br>\n";
          break;
        case 1: // html-auflistung, kein baum
          echo "<li><nobr>".$thread_fontPre;
          if ($thread_showDate)
            echo formatDate($c)." ";
          if ($thread_showSubject)
            echo formatSubject($c,$group)." ";
          if ($thread_showAuthor)
            echo "<i>(".formatAuthor($c).")</i>";
          echo $thread_fontPost."</nobr></li>";
          break;
        case 2:   // table
          echo "<tr>";
          if ($thread_showDate)
            echo "<td>".$thread_fontPre.formatDate($c)." ".$thread_fontPost."</td>";
          if ($thread_showSubject) {
            echo '<td nowrap="nowrap">'.$thread_fontPre.formatSubject($c,$group);
            echo $thread_fontPost."</td>";
          }
          if ($thread_showAuthor) {
            echo "<td></td>";
            echo '<td nowrap="nowrap">'.$thread_fontPre.formatAuthor($c);
            echo $thread_fontPost."</td>";
          }
          echo "</tr>\n";
          break;
        case 3: // html-tree
          echo "<li><nobr>".$thread_fontPre;
          if ($thread_showDate)
            echo formatDate($c)." ";
          if ($thread_showSubject)
            echo formatSubject($c,$group)." ";
          if ($thread_showAuthor)
            echo "<i>(".formatAuthor($c).")</i>";
          echo $thread_fontPost."</nobr>\n";
          break;
        case 4:  // thread
          echo "<nobr><tt>".$thread_fontPre;
          if ($thread_showDate)
            echo formatDate($c)." ";
          echo formatTreeText($newtree)." ";
          if ($thread_showSubject)
            echo formatSubject($c,$group)." ";
          if ($thread_showAuthor)
            echo "<i>(".formatAuthor($c).")</i>";
          echo $thread_fontPost."</tt></nobr><br>";
          break;
        case 5:  // thread, graphic
          echo "<table cellspacing=\"0\" cellpadding=\"0\" border=\"0\"><tr>\n";
          if ($thread_showDate)
            echo '<td nowrap="nowrap">'.$thread_fontPre.formatDate($c)." ".$thread_fontPost."</td>";
          echo "<td>".$thread_fontPre.formatTreeGraphic($newtree).$thread_fontPost."</td>";
          if ($thread_showSubject)
            echo '<td nowrap="nowrap">'.$thread_fontPre."&nbsp;".formatSubject($c,$group)." ";
          if ($thread_showAuthor)
            echo "(".formatAuthor($c).")".$thread_fontPost."</td>";
          echo "</tr></table>";
          break;
        case 6:  // thread, table
          echo "<tr>";
          if ($thread_showDate)
            echo '<td nowrap="nowrap"><tt>'.$thread_fontPre.formatDate($c)." ".$thread_fontPost."</tt></td>";
          echo '<td nowrap="nowrap"><tt>'.$thread_fontPre.formatTreeText($newtree)." ";
          if ($thread_showSubject) {
            echo formatSubject($c,$group).$thread_fontPost."</tt></td>";
            echo "<td></td>";
          }
          if ($thread_showAuthor)
            echo '<td nowrap="nowrap"><tt>'.$thread_fontPre.formatAuthor($c).$thread_fontPost."</tt></td>";
          echo "</tr>";
          break;
        case 7:  // thread, table, graphic
          echo "<tr>";
          if ($thread_showDate)
            echo '<td nowrap="nowrap">'.$thread_fontPre.formatDate($c)." ".$thread_fontPost."</td>";
          echo "<td><table cellspacing=\"0\" cellpadding=\"0\" border=\"1\">\n";
          echo "<td>".formatTreeGraphic($newtree)."</td>";
          if ($thread_showSubject)
            echo '<td nowrap="nowrap">'.$thread_fontPre."&nbsp;".formatSubject($c,$group).$thread_fontPost."</td>";
          echo "</table></td>";
          if ($thread_showSubject) echo "<td></td>";
          if ($thread_showAuthor)
            echo '<td nowrap="nowrap">'.$thread_fontPre.formatAuthor($c).$thread_fontPost."</td>";
          echo "</tr>";
          break;
      }
    }
    if ((isset($c->answers[0])) && (count($c->answers)>0) &&
        ($article_count<=$article_last)) {
      if ($thread_treestyle >= 4) {
        if (substr($newtree,$depth-2,1) == "+")
          $newtree=str_change($newtree,$depth-2,"i");
        $newtree=str_change($newtree,$depth-1,"+");
        $newtree=strtr($newtree,"`",".");
      }
      if (!isset($newtree)) $newtree="";
      showThread($headers,$c->answers,$depth+1,$newtree."",$group,
                 $article_first,$article_last,$article_count);
    }
    flush();
  }
  if ($thread_treestyle==3) echo "</UL>";
}

function loadThreadData($group) {
  global $spooldir,$compress_spoolfiles;
  $filename=$spooldir."/".$group."-data.dat";
  if ($compress_spoolfiles) {
    $file=gzopen("$spooldir/$group-data.dat","r");
    $headers=unserialize(gzread($file,1000000));
    gzclose($file);
  } else {
    $file=fopen($filename,"r");
    $headers=unserialize(fread($file,filesize($filename)));
    fclose($file);
  }
  echo "<!--".count($headers)."-->\n";
  return($headers);
}

function saveThreadData($headers,$group) {
  global $spooldir,$compress_spoolfiles;
  if ($compress_spoolfiles) {
    $file=gzopen("$spooldir/$group-data.dat","w");
    gzputs($file,serialize($headers));
    gzclose($file);
  } else {
	  /*
    $file=fopen("$spooldir/$group-data.dat","w");
    fputs($file,serialize($headers));
    fclose($file);
	*/
  }
}


function showHeaders(&$headers,$group,$article_first=0,$article_last=0,&$spoolopenmodus) {
  global $thread_showDate, $thread_showTable;
  global $thread_showAuthor,$thread_showSubject;
  global $text_thread,$thread_treestyle;
  
  $article_count=0;

  if ($headers == false) {
    echo $text_thread["no_articles"];
  } else {
    if ($spoolopenmodus != "n") {
      reset($headers);
      $c=current($headers);      // read one article
      for ($i=0 ; $i<=count($headers)-1 ; $i++) {
        if (($c->isAnswer == false) &&
           (isset($c->references[0]))) {   // is the article an answer to an
                                          // other article?
          $o=count($c->references)-1;
          $ref=$c->references[$o];
          while (($o >= 0) && (!isset($headers[$ref]))) {  // try to find a
            $ref=$c->references[$o];                       // matching article
            $o--;                                          // to the reference
          }
          if ($o >= 0) {          // found a matching article?
            $c->isAnswer=true;    // so the Article is an answer
            $headers[$c->id]=$c;
            $headers[$ref]->answers[]=$c->id;  // the referenced article gets
                                               // the ID if the article
          }
        }
        $c=next($headers);
      }
      reset($headers);
      saveThreadData($headers,$group);
    }

	reset($headers);
    
	$c=current($headers);
    
	for ($i=0; $i<=count($headers)-1; $i++) {  // create the array $liste
      if ($c->isAnswer == false) {             // where are all the articles
        $liste[]=$c->id;                       // in that don't have
      }                                        // references
      $c=next($headers);
    }

    reset($liste);
    
	if (count($liste)>0) {

	  if (($thread_treestyle==2) || ($thread_treestyle==6) ||
          ($thread_treestyle==7)) {
        echo "<table cellspacing=\"0\" cellpadding=\"0\" border=\"0\">\n";
        echo "<tr>\n";
        if ($thread_showDate) echo "<td>".$text_thread["date"]."&nbsp;</td>";
        if ($thread_showSubject) echo "<td>".$text_thread["subject"]."</td>";
        if ($thread_showAuthor) {
          echo "<td>&nbsp;&nbsp;</td>";
          echo "<td>".$text_thread["author"]."</td>\n";
        }
        echo "</tr>\n";
        showThread($headers,$liste,1,"",$group,$article_first,$article_last,
                   $article_count);
        echo "</table>\n";
      } else {
        if ($thread_treestyle==1) echo "<ul>\n";
        showThread($headers,$liste,1,"",$group,$article_first,$article_last,
                   $article_count);
        if ($thread_treestyle==1) echo "</ul>\n";
      }

    }
  }
}

/*
function showAntwortKnopf($group,$id) {
  global $file_post;
  echo "<form action=\"$file_post\" method=post>\n";
  echo "<input type=submit value=\"Antworten\"\n>";
  echo "<input type=hidden name=\"type\" value=\"reply\">\n";
  echo "<input type=hidden name=\"id\" value=\"$id\">\n";
  echo "<input type=hidden name=\"group\" value=\"$group\">\n";
  echo "</form>\n";
}
/*

/*
 * print an article to the webpage
 *
 * $von: The handler of the NNTP-Connection
 * $group: The group of the article
 * $id: the ID of the article inside the group or the message-id
 */
function showArticle(&$von,$group,$id) {
  global $file_article;
  if ($von == false) return;
  global $article_show,$text_header,$article_showthread;
  $head=readHeader($von,$group,$id);
  if (strcmp($head,false) != 0) {
    $body=readBody($von,$id,$head->content_transfer_encoding);
    if ($article_show["Subject"]) echo $text_header["subject"].htmlspecialchars($head->subject)."<br>";
    if ($article_show["From"]) {
      echo $text_header["from"].'<a href="mailto:'.htmlspecialchars($head->from).'">'.$head->from.'</a> ';
      if ($head->name != "") echo '('.htmlspecialchars($head->name).')';
      echo "<br>";
    }
    if ($article_show["Newsgroups"]) 
      echo $text_header["newsgroups"].htmlspecialchars($head->newsgroups)."<br>\n";
    if (isset($head->followup) && ($article_show["Followup"]) && ($head->followup != "")) 
      echo $text_header["followup"].htmlspecialchars($head->followup)."<br>\n";
    if ((isset($head->organization)) && ($article_show["Organization"]) &&
       ($head->organization != ""))
      echo $text_header["organization"].
           htmlparse(htmlspecialchars($head->organization))."<br>\n";
    if ($article_show["Date"])
      echo $text_header["date"].date($text_header["date_format"],$head->date)."<br>\n";
    if ($article_show["Message-ID"])
      echo $text_header["message-id"].htmlspecialchars($head->id)."<br>\n";
    if (($article_show["References"]) && (isset($head->references[0]))) {
      echo $text_header["references"];
      for ($i=0; $i<=count($head->references)-1; $i++) {
        $ref=$head->references[$i];
        echo ' '.'<a href="'.$file_article.'?id='.urlencode($ref).
             '&group='.$group.'">'.($i+1).'</a>';
      }
      echo "<br>";
    }
    if (isset($head->user_agent)) {
      if ((isset($article_show["User-Agent"])) &&
         ($article_show["User-Agent"])) {
        echo $text_header["user-agent"].htmlspecialchars($head->user_agent)."<br>\n";
      } else {
        echo "<!-- User-Agent: ".htmlspecialchars($head->user_agent)." -->\n";
      }
    }
    echo "<pre>\n";
    for ($i=0; $i<=count($body)-1; $i++) {
      $b=textwrap($body[$i],80,"\n");
      if ((strpos(substr($b,0,strpos($b," ")),'>') != false ) | (strcmp(substr($b,0,1),'>') == 0)) {
        echo "<i>".htmlparse(htmlspecialchars($b))."</i>\n";
      } else {
        echo htmlparse(htmlspecialchars($b))."\n";
      }
    } 
    echo "\n</pre>\n";
  }
  if ($article_showthread > 0) {

  }
}

/*
 * Post an article to a newsgroup
 *
 * $subject: The Subject of the article
 * $from: The authors name and email of the article
 * $newsgroups: The groups to post to
 * $ref: The references of the article
 * $body: The article itself
 */
function verschicken($subject,$from,$newsgroups,$ref,$body) {
  global $server,$port,$send_poster_host,$organization,$text_error;
  global $file_footer;
  flush();
  $ns=OpenNNTPconnection($server,$port);
  if ($ns != false) {
    fputs($ns,"post\r\n");
    $weg=lieszeile($ns);
    fputs($ns,"Subject: $subject\r\n");
    fputs($ns,"From: $from\r\n");
    fputs($ns,"Sender: $from\r\n");
    fputs($ns,"Newsgroups: $newsgroups\r\n");
    fputs($ns,"Content-Type: text/plain; charset=ISO-8859-1\r\n");
    fputs($ns,"Content-Transfer-Encoding: 8bit\r\n");
    fputs($ns,"User-Agent: NewsPortal 0.23\r\n");
    if ($send_poster_host)
      fputs($ns,"X-HTTP-Posting-Host: ".gethostbyaddr(getenv("REMOTE_ADDR"))."\r\n");
    if ($ref!=false) fputs($ns,"References: $ref\r\n");
    if (isset($organization)) fputs($ns,"Organization: $organization\r\n");
    if ((isset($file_footer)) && ($file_footer!="")) {
      $footerfile=fopen($file_footer,"r");
      $body.="\n".fread($footerfile,filesize($file_footer));
      fclose($footerfile);
    }
    $body=ereg_replace("\r",'',$body);
    $body=str_replace("\n.\n","\n..\n",$body);
    $b=split("\n",$body);
    $body="";
    for ($i=0; $i<count($b); $i++) {
      if ((strpos(substr($b[$i],0,strpos($b[$i]," ")),">") != false ) | (strcmp(substr($b[$i],0,1),">") == 0)) {
        $body .= textwrap(stripSlashes($b[$i]),78,"\r\n")."\r\n";
      } else {
        $body .= textwrap(stripSlashes($b[$i]),74,"\r\n")."\r\n";
      }
    }
    fputs($ns,"\r\n".$body."\r\n.\r\n");
    $message=lieszeile($ns);
    closeNNTPconnection($ns);
  } else {
    $message=$text_error["post_failed"];
  }
  return $message;
}

?>
