<?


include_once("comm.dbConnection.php");


class structured_thread
{
	var $depth;
	var $id;
	var $number;
	var $subject;
	var $from;
	var $name;
	var $date;
	var $pictureURL;
	var $references;
	var $content_transfer_encoding;
}


function showThreadTree($headers, $iDepth, $bThreadsCollapsed)
{
	$structured_headers = array();
	$parent_headers = array();

	foreach ($headers as $header)
	{
		$references = $header->references;
	
		if (count($references) == 0) array_push($parent_headers, $header);
	}

	foreach ($parent_headers as $parent)
	{
		$structured_thread = new structured_thread();
		$structured_thread->depth = 0;
		$structured_thread->isAnswer = $parent->isAnswer;
		$structured_thread->answers = $parent->answers;
		$structured_thread->id = $parent->id;
		$structured_thread->number = $parent->number;
		$structured_thread->subject = $parent->subject;
		$structured_thread->from = $parent->from;
		$structured_thread->name = $parent->name;
		$structured_thread->date = $parent->date;
		$structured_thread->pictureURL = $parent->pictureURL;
		$structured_thread->references = $parent->references;
		$structured_thread->content_transfer_encoding = $parent->content_transfer_encoding;

		array_push($structured_headers, $structured_thread);

		if (!$bThreadsCollapsed)
			showChildren($parent, $headers, 1, "&nbsp;&nbsp;", $structured_headers);

	}

	return $structured_headers;
}


function showChildren($parent_header, $headers, $iDepth, $sSpacing, &$target_headers)
{
	$child_headers = array();

	foreach ($headers as $header)
	{
		$references = $header->references;
		
		if (count($references) > 0)
		{
			foreach ($references as $reference)
			{

				if (count($references) == $iDepth)
				{
					if ($reference == $parent_header->id)
					{
						array_push($child_headers, $header);
					}
				}
			}
		}
	}


	// Now that we have all of the child articles, print them out.
	foreach ($child_headers as $child_header)
	{
		$structured_thread = new structured_thread();
		$structured_thread->depth = $iDepth;
		$structured_thread->id = $child_header->id;
		$structured_thread->number = $child_header->number;
		$structured_thread->subject = $child_header->subject;
		$structured_thread->from = $child_header->from;
		$structured_thread->name = $child_header->name;
		$structured_thread->date = $child_header->date;
		$structured_thread->references = $child_header->references;
		$structured_thread->pictureURL = $child_header->pictureURL;
		$structured_thread->content_transfer_encoding = $child_header->content_transfer_encoding;

		array_push($target_headers, $structured_thread);
//		echo $sSpacing . $child_header->number . ".) " . $child_header->subject . "<br>\n";
		showChildren($child_header, $headers, $iDepth + 1, $sSpacing . "&nbsp;&nbsp;", $target_headers);
	}

}


function getHeaderDepth($header, $headers, $iDepth)
{
	$iReturn = 0;
	$current_headers = array();


	foreach ($headers as $oHeader)
	{
		$references = $oHeader->references;

		if (count($references) == $iDepth) array_push($current_headers, $oHeader);
	}

	
	foreach ($current_headers as $oSingleHeader)
	{
		if ($oSingleHeader->id == $header->id) return $iDepth;
		else 
		{
			$iReturn = getHeaderDepth($header, $headers, $iDepth + 1);
		}
	}

	return $iReturn;
}


function getLatestPostDate($newsgroup)
{

	// Open a connection to the NNTP server.
	$ns = OpenNNTPconnection($server, $port);

	// Only if the connection was opened, continue.
	if ($ns != false) {
		$headers = array();
		//var $latestDate;
		$foo = 0;
		$headers = readOverview($ns, $newsgroup, 1, $foo);

		for ($i = 0; $i < count($headers); $i++)
		{
			$oCurrentHeader = $headers[$i];

			$latestDate = $oCurrentHeader->date;
		}
		
	}

	return $latestDate;
}


function getNewsGroupInfo($headers)
{
	$new_headers = array();
	//var $lastPostDate;


	foreach ($headers as $oHeader)
	{
//		$lastPostDate = getLatestPostDate($oHeader->name);

		$newHeader = array();
		$newHeader->name = $oHeader->name;
		$newHeader->description = $oHeader->description;
		$newHeader->count = $oHeader->count;
		$newHeader->last_post_date = $lastPostDate;

		array_push($new_headers, $newHeader);
	}

	return $new_headers;
}


function buildUserHash()
{
	
	// Build the SQL statement.
	$SQL = "SELECT user_nickname, " .
		   "       user_pic_url " .
		   "FROM registered_user";

	// Create a new DB connection.
	$conn = new dbConnection();

	// Open the connection.
	$conn->openConnection();

	// Execute the query.
	$conn->executeQuery($SQL);

	$aTempUserHash = array();
	while ($aUserInfo = $conn->fetchNextRow())
	{
		$sNickName = $aUserInfo["user_nickname"];
		$aTempUserHash[$sNickName] = $aUserInfo;
	}

	return $aTempUserHash;

}


?>