<?php

include_once("global.php");
include_once("mavsfan.registered_user.manager.php");

// Dim and init any vars necessary.
if (!isset($returnto)) $returnto = "";

// Register a session-level variable.
session_register("saUserInfo");
session_register("sbValidated");


// Create a user manager.
$oUserManager = new registered_user_manager();

// Attempt to validate the user's info.
// Returns false if he/she is denied.
if (!$aUserInfo = $oUserManager->validateUser($EmailAddr, $Password))
{
	// If login failed, let's create a template and error out gracefully.
	$template = new Smarty();


	// Assign in the error stuff.
	$template->assign("error_desc", "<b>Invalid login information supplied. Please try again.</b><br>" .
		                            "<br>" .
		                            "Remember, this could be caused by numerous things:<br>" .
		                            "<ul>" .
		                            "    <li>You never validated your account by visiting the URL sent to you upon registration.</li>" .
		                            "    <li>There is no such e-mail address registered within the system.</li>" .
		                            "    <li>You supplied an incorrect password.</li>");

	$template->assign("action_desc", "validate your login information");

	// Display it.
	$template->display("error_page.tpl");

	die();
}


// We can now assume they gave us the correct info, and this, in fact,
// the correct person. We need to store their info in a session.

// Assign the array we just got, back to that session var.
$saUserInfo = $aUserInfo;
$sbValidated = true;


// Redirect back to the home page.
if ($returnto == "")
{
	header("Location: index.php");
}
else
{
	header("Location: " . $returnto);
}


?>