<?php

include_once("global.php");
include_once("mavsfan.registered_user.manager.php");


// Register any session variables.
session_register("saUserInfo");
session_register("aUserInfoHash");


// Now, let's display a confirmation page.
$template = new Smarty();


$sErrorAction = "change your password";

// Check for required fields.
if ($user_f_name == "" ||
	$user_l_name == "")
{
	$sErrorDesc = "<ul>\n";

	if ($user_f_name == "")
	{
		$sErrorDesc .= "<li>First Name must be supplied.</li>";
	}

	if ($user_l_name == "")
	{
		$sErrorDesc .= "<li>Last Name must be supplied.</li>";
	}

	$sErrorDesc .= "</ul>\n";
}

// Check to see if they're attempting to change their password.
if ($user_password != "" &&
    (
     ($user_password_confirm == "") ||
     ($user_password_confirm != $user_password)
    ))
{

	$sErrorDesc .= "<b>Check to make sure you've confirmed the password you entered, " .
		      "and double-check that both the password and password confirmation " .
		      "match.</b>";
	
}


// If any errors arised, display the error page.
if ($sErrorDesc != "")
{

	// Assign in the error verbiage.
	$template->assign("error_desc", $sErrorDesc);
	$template->assign("action_desc", $sErrorAction);

	// Display the template.
	$template->display("error_page.tpl");

	die();

}



// Create the user object.
$oUserManager = new registered_user_manager();

// Attempt to update the user account.
$oUserManager->update_account_info($saUserInfo["user_id"], $user_f_name, $user_l_name, $user_display_email_addr, $user_password, $user_signature, $user_pic_url);

// Updated the user information hash.
$aUserInfoHash = buildUserHash();


// We need to re-initialize the user session object.
$aUserInfo = $oUserManager->validateUser($saUserInfo["user_email_addr"], ($user_password != "" ? $user_password : $saUserInfo["user_password"]));

// Resave the session variable.
$saUserInfo = $aUserInfo;

$template->display("account_info.updated.tpl");


?>